#include <ft2build.h>
#include FT_FREETYPE_H
#include FT_GLYPH_H
#include "bmpheader.h"
#include <string.h>
#include <locale.h>
#define MAX_GLYPH 256

unsigned char* string = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZgWAVEbp";
                        /*only 'j' and 'Q' are two rather "high" characters ! */
wchar_t unicode_text[MAX_GLYPH];

#define MAX_GLYPH_NUM 512

typedef struct TGlyph_ {
	FT_UInt   glyph_index;
	FT_Vector pos;
	FT_Glyph  image;
	FT_Vector delta;
	int       adv;
	FT_Pos    bear_y_neg;
	FT_Pos    bear_x_neg;
}TGlyph, * PGlyph;

typedef struct TBmp_ {
	int height;
	int width;
	unsigned char* imagedata;
}TBmp;

FILE*  fp;
static TGlyph glyphs[MAX_GLYPH_NUM];
static int num_glyph;
static FT_Face face;




static void prepare_text(unsigned char* string2){
	unsigned char* p = string2;
	char* old_locale, * saved_locale, *set_locale;
	PGlyph glyph = glyphs;
	int glyph_index;
        int length = 0;
	int i;
	int num_glyphs;

	FT_UInt previous;
	FT_Bool use_kerning;

	FT_Error error;

	previous    = 0; 
	use_kerning = FT_HAS_KERNING(face);
	if (use_kerning){
	  printf("use kerning .\n");
	  getchar();
	}
	else{
	  printf("not use kerning .\n");
	  getchar();
	}
	
	
	num_glyph  = 0;

	printf("input string is %s.\n", string2);
	old_locale = setlocale(LC_ALL, NULL);

	saved_locale = strdup(old_locale);


	
	if( (set_locale = setlocale(LC_ALL, "zh_CN.GB2312" )) ==  NULL  ){
	  printf(" set locale error.\n");
	  return;
	}
	else {
	  printf("now the locale is set to be %s\n", set_locale);
	}
	

	

	length = strlen(string2);
	printf("length by strlen is %d\n", length);
	printf("the string2 octal form is:\n");
	for(i=0; i< length; i++)
		printf("%x ", (unsigned int)string2[i]);
	printf("\n");

	num_glyphs = mbstowcs(unicode_text, string2, length);
	printf("num_glyphs by mbstowcs is %d\n", num_glyphs);    
       if(num_glyphs > MAX_GLYPH)	num_glyphs = MAX_GLYPH;

	printf("the unicode string octal form is:\n");
	for(i = 0; i < num_glyphs; i++){
	  printf("%x ", (unsigned int)unicode_text[i]);
	}
	printf("\n");


	old_locale = setlocale(LC_ALL, saved_locale);
	printf("the old locale is %s\n", old_locale);
	
	while(num_glyph < num_glyphs){
		glyph_index = FT_Get_Char_Index(face, (FT_ULong) unicode_text[num_glyph] );
		glyph->glyph_index = glyph_index;
		printf("\nthe %d th 's glyph index is %d \n", num_glyph, glyph_index);
		
		if ( use_kerning && previous && glyph_index  ){
		  FT_Get_Kerning( face, previous, glyph_index, ft_kerning_default, 	\
				  &(glyph->delta)  );
		  printf("the delta between %d and %d is %d\n", previous, glyph_index, (glyph->delta).x);
		}
		previous = glyph_index;

		/*horiBearingY*/
		error = FT_Load_Glyph(face, glyph_index, 0 /*load_flags*/);
		if(error){
		  printf("load glyph error.\n");
		  return;
		}
		glyph->bear_y_neg = (face->glyph->metrics.height - face->glyph->metrics.horiBearingY) >> 6;
		glyph->bear_x_neg =  face->glyph->metrics.horiBearingX >> 6;
		printf("this glyph's bear_y is %d\n\n", glyph->bear_y_neg);
		printf("this glyph's bear_x is %d\n\n", glyph->bear_x_neg);
		//getchar();
			
		glyph++;
		num_glyph++;
		if(num_glyph > MAX_GLYPH_NUM)
			break;
		p++;
	}
}



void write_bmpfiledata(FILE* fp, FT_Bitmap bmp){

  int l,h;

  for(h = bmp.rows - 1; h >= 0; h--){
    int delta = 0;
    char c[1];
    int i; 
    
    c[0] = 0; 
    l = fwrite(bmp.buffer + bmp.width * h , sizeof(char), bmp.width,fp  );
 
    if (l != bmp.width)
	  printf("written bytes number error.\n");

    delta = (((bmp.width + 3L)>>2)<<2) - bmp.width;
    if(delta > 0)
       for(i = 0; i < delta; i++ )
	    fwrite(c, sizeof(char), 1, fp);
  }

}



void main(int argc, char** argv){
  FT_Library library;
  FT_Error   error;
//FT_Face    face;
  FT_UInt    glyph_index;
  FT_Bitmap  bmp;
  FT_Glyph   glyph;
  FT_BitmapGlyph  post_glyph;
  int             n,i,j,k, maxh, advance, sumadvance, max_bear_y_neg, lmaxh;


  unsigned char** pbitmapArray;
  unsigned char*  plargeBitmap;
  struct TBmp*    PBmp;

  char*          ttffilename;

  FT_Glyph_Metrics metrics;
  
//FT_GlyphSlot slot = face->glyph; 
//int 		pen_x, pen_y;
  
  fp = fopen("output.bmp","wb");
  if(fp == NULL){
    printf("cannot open file.\n");
    return;
  }



  
  ttffilename = "/usr/share/fonts/default/TrueType/simkai.ttf";
  
  if(argc < 2){
    printf("use default string and default fontfile: %s; %s\n", string, ttffilename);
  }
  if(argc == 2){
    printf("use only default fontfile: %s\n", ttffilename);
    string = argv[1];
    
  }
  else if(argc > 2){
    string = argv[1];
    ttffilename = argv[2];
    printf("indicated string is %s\n", string);
    printf("indicated font   is %s\n", ttffilename);
  }
  
  error = FT_Init_FreeType( &library  );
  if( error  ){
  	printf("Init error.\n");
	return;
  }
  else
	printf("Init good.\n");

  

  
  error = FT_New_Face( library, ttffilename,   0, &face  );
  if(error == FT_Err_Unknown_File_Format){
    printf("error the font is of unknown format.\n");
    return;
  }
  else if(error){
    printf("error unknown.\n");
    return;
  }
  else{
    printf("good. such as: the num_glyphs-----no of glyphs is %d.\n", face->num_glyphs);
    printf("the num of faces is %d.\n", face->num_faces);
  }



  {
  int num_charmap = face->num_charmaps;
  FT_CharMap charmap;
  
  printf("the number of charmaps is %d \n", num_charmap);
  for(n = 0; n < num_charmap; n++){
    charmap = face -> charmaps[n];
    printf("the charmap platform id is %d, encoding id is %d \n", 	\
		    charmap->platform_id, charmap->encoding_id);
    /*
    printf("those character codings are: %d %d %d %d %d %d %d %d\n", 	\
	    FT_ENC_TAG(ft_encoding_none, 0, 0, 0, 0 ), 			\
	    FT_ENC_TAG(ft_encoding_symbol,'s', 'y', 'm', 'b'), 		\
	    FT_ENC_TAG(ft_encoding_unicode,'u', 'n', 'i', 'c' ),	\
	    FT_ENC_TAG(ft_encoding_latin_1,'l', 'a', 't', '1' ),	\
	    FT_ENC_TAG(ft_encoding_latin_2,'l', 'a', 't', '2' ),	\	
	    FT_ENC_TAG(ft_encoding_sjis, 's', 'j', 'i', 's' ), 		\
	    FT_ENC_TAG(ft_encoding_gb2312, 'g', 'b', ' ', ' '),		\
	    FT_ENC_TAG(ft_encoding_big5, 'b', 'i', 'g', '5')		\
         );
    */
  }
  
  error = FT_Select_Charmap(face, ft_encoding_unicode);
  //error = FT_Set_Charmap(face, ft_encoding_unicode);
  if(error){
    printf("select unicode character encoding error.\n");
    return;
  }
  
  }

  
                                     /*   a/72 * resolution   */
                                     /*   64/72 * resolution   */

  error = FT_Set_Char_Size( face, 0,15*64, 72, 72  );
  //error = FT_Set_Char_Size( face, 64<<6,64<<6 , 0, 0  );
  if(error){
    printf("set char size error.\n");
    return;
  }

  
  {
  FT_ULong charcode = 'W'/*66*/;
  glyph_index = FT_Get_Char_Index(face , charcode);
  }



  {
  prepare_text(string);
  }



maxh           = 0;
advance        = 0;

max_bear_y_neg = 0;
  

pbitmapArray = (unsigned char** )malloc(num_glyph * sizeof(unsigned char* ));
if(pbitmapArray == NULL){
  printf("malloc error.\n");
  return;
}

PBmp = (struct TBmp* )malloc(num_glyph * sizeof(TBmp));
if(PBmp == NULL){
  printf("malloc error.\n");
  return;
}
printf("the PBmp's addr is  %p %p, PBMP's member are: height--(%d) \n",	\
		PBmp, (TBmp* )PBmp + 1, ( *(  (TBmp* )PBmp + 1 ) ).height  );



for(n = 0; n < num_glyph; n++){

  glyph_index = glyphs[n].glyph_index;
  /*
  if(n == 6) glyph_index = 4133;
  if(n == 7) glyph_index = 3017;
  if(n == 8) glyph_index = 2187;
  */
  if( n > num_glyph  ){
    printf("the n is too large\n");
    return;
  }
  
  error = FT_Load_Glyph(face, glyph_index, 0 /*load_flags*/);
  if(error){
    printf("load glyph error.\n");
    return;
  }

  
  error = FT_Get_Glyph(face->glyph, &glyph);
  if(error){
    printf("get glyph object error.\n");
    return;
  }

  /*metrics*/
  {
    metrics = face->glyph->metrics;
    printf("\n\n\tthe %d glyph's metrics are:\n", n);
    printf("\n\twidth\theight\thorBrX\thorBrY\thorAdv\n");
    printf("\t---------------------------------------------\n");
    printf("\t%d\t%d\t%d\t%d\t%d\n\n", metrics.width, metrics.height, 	\
		    metrics.horiBearingX, metrics.horiBearingY, metrics.horiAdvance);
    //getchar();
  }

  
  if( face->glyph->format !=  ft_glyph_format_bitmap){
    printf("this is not of a bitmap format.\n");
 
    error = FT_Render_Glyph(face->glyph, 0 /* render_mode*/);
    if(error){
      printf(" render glyph error.\n");
      return;
    }
  }

  //the first method
  
  
  {
	 if(argc > 1) printf("\n\nit's --  %c  -- 's bitmap:\n", *(argv[1] + n) );
  printf("the bitmap left is %d, the top is %d, dvance.x is %d, advance.y is %d\n", 	\
	face->glyph->bitmap_left, face->glyph->bitmap_top, face->glyph->advance.x, face->glyph->advance.y);
  glyphs[n].adv = (face->glyph->advance.x) >> 6;
  /*needs we do such modification ???   */
  
  bmp = face->glyph->bitmap;
  printf("the bitmap:\n rows\twidth\tpitch\tnum_grays\tbuffer()\tpel_mode\tpal_mode\tpal()\n%d\t%d\t%d\t%d\t\t%c\t%c\t\t\n\n",  bmp.rows, bmp.width, bmp.pitch, bmp.num_grays, bmp.pixel_mode, bmp.palette_mode);
 
  //if(glyphs[n].adv < bmp.width)
  //	  glyphs[n].adv = bmp.width;
  /*need it ???*/
  //if(glyphs[n].bear_x_neg < 0)
  //     glyphs[n].adv += glyphs[n].bear_x_neg;
  /*AND	 be this one needed ??? */
  }
  


 if (bmp.rows > maxh)
	 maxh = bmp.rows;
 
 if (glyphs[n].bear_y_neg > max_bear_y_neg)
	 max_bear_y_neg = glyphs[n].bear_y_neg;
 
 if(n == 0) {
	 advance = face->glyph->advance.x >>6;
 }//may be deleted now


  {
  int h;
  
  pbitmapArray[n] = (unsigned char* )malloc(bmp.width * bmp.rows * sizeof(unsigned char));
  
  if(pbitmapArray[n] == NULL){
    printf("malloc error.\n");
    return;
  }
  else{
    printf("\n\n\n", n,  bmp.width* bmp.rows);
    //getchar();
  }

  (*((TBmp* )PBmp + n)).imagedata = pbitmapArray[n];
  (*((TBmp* )PBmp + n)).height    = bmp.rows;
  (*((TBmp* )PBmp + n)).width     = bmp.width;
  
  for(h = 0 ; h < bmp.rows; h++)
    memcpy( pbitmapArray[n] + bmp.width * h , bmp.buffer + bmp.width * h, bmp.width );
    
  }





 


 //the second/direct method
  /*
  {	  FT_Vector       origin;
	  
	  origin.x = 64;
	  origin.y = 0;
	  
	  error = FT_Glyph_To_Bitmap( &glyph , 0,  &origin, 1  );
	  post_glyph =  (FT_BitmapGlyph) (glyph);
	  printf("the post_glyph's left is %d, top is %d \n", post_glyph->left, post_glyph->top);

	  bmp = post_glyph -> bitmap;
          printf("the bitmap:\n rows\twidth\tpitch\tnum_grays\tbuffer()\tpel_mode\tpal_mode\tpal()\n%d\t%d\t%d\t%d\t\t%c\t%c\t\t\n",  bmp.rows, bmp.width, bmp.pitch, bmp.num_grays, bmp.pixel_mode, bmp.palette_mode);
 }
  */

}//for num_glyphs




printf("\nthe maxh is %d, the advance is %d, the max_bear_y_neg is %d.\n", maxh, advance,max_bear_y_neg);

printf("but we must use lmaxh as %d", maxh + max_bear_y_neg);
lmaxh = maxh +  max_bear_y_neg;
printf("\n");

sumadvance = 0; 
for(n = 0; n < num_glyph-1; n++){
  sumadvance += glyphs[n].adv;
  /*
  sumadvance += (glyphs[n].delta.x >> 6) ;
  if(glyphs[n].bear_x_neg < 0)
     sumadvance += glyphs[n].bear_x_neg;
  //is this needed?
  */
}
//sumadvance += (((*((TBmp* )PBmp + n)).width > glyphs[n].adv)? (*((TBmp* )PBmp + n)).width : glyphs[n].adv ) ;
if(glyphs[0].bear_x_neg < 0)
    sumadvance -= glyphs[0].bear_x_neg;
sumadvance += glyphs[n].bear_x_neg + (*((TBmp* )PBmp + n)).width  ;
/*this is a double subtle detail*/
/*this is   triple/quar  subtle ! */

printf("\nthe last letter, that is the %dth width is %d\n", n,  (*((TBmp* )PBmp + n)).width );


plargeBitmap = (unsigned char* )malloc(sumadvance * lmaxh * sizeof(unsigned char));

memset(plargeBitmap , 0, lmaxh * sumadvance);//may be not so large

for(n = 0; n < lmaxh; n++){
  
  for(i = 0; i < num_glyph; i++){
	  
    int gap1, gap2;
    int front = 0;
    static int old_front ;
    static int old_width;

    int wtemp = ( *( (TBmp* )PBmp + i  ) ).width;
    
    for(j = 0; j < i; j++){
      front +=  glyphs[j].adv;
    
      front += (glyphs[j+1].delta.x >> 6);
      /*
      if (n == 0)
         printf("\ni = %d, front is adjusted by kerning delta value: %d\n",i,  glyphs[j+1].delta.x>>6 );
      
      if(glyphs[j+1].bear_x_neg < 0){//a colon is a bug here , hehe!
         front += glyphs[j+1].bear_x_neg;
         if (n == 0 && glyphs[j+1].bear_x_neg < 0)
    	       printf("\nfront is reducted by bear_x_neg value: %d\n", glyphs[j+1].bear_x_neg);
      }
      */
      
    }
    front += glyphs[i].bear_x_neg;
    if(glyphs[0].bear_x_neg < 0)
	    front -= glyphs[0].bear_x_neg;

    gap1 = maxh - (*((TBmp* )PBmp + i)).height;
    
    gap2 = gap1 + glyphs[i].bear_y_neg; 

    if(n == 0){
	    printf("\ni = %d, the gap1 is %d, gap2 is %d\n", i, gap1, gap2);
	    printf("maxh is %d, max_bear_y_neg is %d, lmaxh is %d\n", maxh, max_bear_y_neg, lmaxh);
	    //getchar();
    }
  
    if( n <  gap2 || 		\
	n >= ( maxh + glyphs[i].bear_y_neg )/*lack of this is the cause of intrinsic bug reporting segmentation fault */ 
      )
	    continue;
    

    //We use this method to avoid overwrite : to overlap them, just OR them.
    //And only when the delta.x < 0, we do this, to avoid unnecessary computing.
    //In this view, the below early consideration is unwise.



    
    if(glyphs[i].delta.x < 0 || glyphs[i].bear_x_neg < 0 ||	\
     	glyphs[i-1].adv <= old_width    )/*this is another critical one!*/
    {
	    for (k = 0; k < wtemp ; k ++){
		    unsigned char* pch1 = pbitmapArray[i] + (n - gap2) * wtemp        + k;
		    unsigned char* pch2 = plargeBitmap    + sumadvance * n    + front + k;
		    *pch1 = (*pch1) | (*pch2);
	    }
    }
    old_front = front;
    old_width = wtemp;
    
    memcpy( plargeBitmap + sumadvance * n  + front, 				\
	    pbitmapArray[i] + ( n - gap2 ) * ( (*((TBmp* )PBmp + i)).width) ,	\
	    (*((TBmp* )PBmp + i)).width						\
          );

    //if the kerning is less than zero, we paint the before bitmap agiain ?
    //but even painting it again doesn't make things any better.
    
	    
  
  }
}

 

  printf("\nthis is coming to having written into the large bitmap successfully.\n\n");

  for(i = 0; i < num_glyph; i++){
     printf("the height and width of it are: height -- %d, width -- %d \n ", 	\
		     (*((TBmp* )PBmp + i)).height,   (*((TBmp* )PBmp + i)).width);
  
  }





  {
	  bmp.rows   = lmaxh;
	  bmp.width  = sumadvance;
	  bmp.buffer = plargeBitmap;
  write_bmpfileheader(fp, bmp.width, bmp.rows);
  

  printf("to write bmp file data, rows = %d, width = %d\n", bmp.rows, bmp.width);
  
  /*if pitch > 0*/
  write_bmpfiledata(fp, bmp);
  
  }
  


  //printf("come here successfully. Is the error by free()? really incredible!\n");


  for(n = 0; n < num_glyph; n++){
	  
     printf("\nbitmap array no:%d to be freed\n", n);
     if(pbitmapArray[n])
	  free(pbitmapArray[n]);
     printf("bitmap array no:%d freed\n", n);
  }
  free(pbitmapArray);

  free(plargeBitmap);
  free(PBmp);

  FT_Done_Glyph(glyph);/*but what means in the html to "instead of" ? */
  fclose(fp);
  

}
